//+------------------------------------------------------------------+
//|                                               CrrelationIndi.mq4 |
//| 2010.2.26                                              kyojee    |
//+------------------------------------------------------------------+
#property copyright "Copyright (c) 2010, kyojee"
#property link      ""

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 MediumSeaGreen
#property indicator_color2 Coral

//---- input parameters
extern int       MAPeriod=100;
extern int       MAMethod=0;
extern string    symbol1="EURUSD";
extern string    symbol2="USDCHF";
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double factor1, factor2;
int    shift=1;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   
   if(factor(symbol1)>factor(symbol2)){
      factor1=1;
      factor2=factor(symbol1)/factor(symbol2);
   }
   if(factor(symbol2)>factor(symbol1)){
      factor1=factor(symbol2)/factor(symbol1);
      factor2=1;
   }
   if(factor(symbol1)==factor(symbol2)){
      factor1=1;
      factor2=1;
   }
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
   int limit = Bars-2;
   
   for(int i=limit;i>=0;i--){
      ExtMapBuffer1[i] = ma(symbol1,iBarShift(symbol1,0,Time[i+shift],false))*factor1;
      ExtMapBuffer2[i] = ma(symbol2,iBarShift(symbol2,0,Time[i+shift],false))*factor2;
   }
//----
   return(0);
  }
  
//+-------------------------------------------------------------------------+
//| MA                                                                      |
//+-------------------------------------------------------------------------+

double ma(string symbol,int shift){
   double ima=iMA(symbol,0,MAPeriod,0,MAMethod,PRICE_CLOSE,shift);
   double ret=(iClose(symbol,0,shift)-ima)/MarketInfo(symbol,MODE_POINT);
   return(ret);
}

//+-------------------------------------------------------------------------+
//| Factor                                                                  |
//+-------------------------------------------------------------------------+

double factor(string symbol){
   double ret=MarketInfo(symbol,MODE_TICKVALUE)/(MarketInfo(symbol,MODE_TICKSIZE)/MarketInfo(symbol,MODE_POINT));
   return(ret);
}